#include "lcd_init.h"

//׼ȷʱ
void delay_ms(unsigned int ms)
{
    DelayMs(ms);
}

void LCD_Writ_Bus(u8 dat)
{
    LCD_CS_LOW();

    SPI0_MasterSendByte( dat );

    LCD_CS_HIGH();
}

/******************************************************************************
˵LCDд
ݣdat д
ֵ  
******************************************************************************/
void LCD_WR_DATA8(u8 dat)
{
    LCD_Writ_Bus(dat);
}

/******************************************************************************
˵LCDд
ݣdat д
ֵ  
******************************************************************************/
void LCD_WR_DATA(u16 dat)
{
    LCD_Writ_Bus(dat>>8);
    LCD_Writ_Bus(dat);
}


/******************************************************************************
˵LCDд
ݣdat д
ֵ  
******************************************************************************/
void LCD_WR_REG(uint8_t  dat)
{
    LCD_DC_LOW();//д
    LCD_Writ_Bus(dat);
    LCD_DC_HIGH();//д
}

/******************************************************************************
      ˵ʼͽַ
      ݣx1,x2 еʼͽַ
                y1,y2 еʼͽַ
      ֵ  
******************************************************************************/
void LCD_Address_Set(u16 x1,u16 y1,u16 x2,u16 y2)
{
    if(USE_HORIZONTAL==0)
    {
        LCD_WR_REG(0x2a);//еַ
        LCD_WR_DATA(x1+24);
        LCD_WR_DATA(x2+24);
        LCD_WR_REG(0x2b);//еַ
        LCD_WR_DATA(y1);
        LCD_WR_DATA(y2);
        LCD_WR_REG(0x2c);//д
    }
    else if(USE_HORIZONTAL==1)
    {
        LCD_WR_REG(0x2a);//еַ
        LCD_WR_DATA(x1+24);
        LCD_WR_DATA(x2+24);
        LCD_WR_REG(0x2b);//еַ
        LCD_WR_DATA(y1);
        LCD_WR_DATA(y2);
        LCD_WR_REG(0x2c);//д
    }
    else if(USE_HORIZONTAL==2)
    {
        LCD_WR_REG(0x2a);//еַ
        LCD_WR_DATA(x1);
        LCD_WR_DATA(x2);
        LCD_WR_REG(0x2b);//еַ
        LCD_WR_DATA(y1+24);
        LCD_WR_DATA(y2+24);
        LCD_WR_REG(0x2c);//д
    }
    else
    {
        LCD_WR_REG(0x2a);//еַ
        LCD_WR_DATA(x1);
        LCD_WR_DATA(x2);
        LCD_WR_REG(0x2b);//еַ
        LCD_WR_DATA(y1+24);
        LCD_WR_DATA(y2+24);
        LCD_WR_REG(0x2c);//д
    }
}

void LCD_Init(void)
{
    GPIOA_ModeCfg(  GPIO_Pin_3 |GPIO_Pin_2 | GPIO_Pin_1 , GPIO_ModeOut_PP_5mA );

     /*  SPI0 :
         PA12/CS
         PA13/SCK
         PA14/MOSI
         PA15/MISO
     */

     GPIOA_SetBits( GPIO_Pin_12 );
     GPIOA_ModeCfg( GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14|GPIO_Pin_15, GPIO_ModeOut_PP_5mA );
     SPI0_MasterDefInit();


    LCD_RES_LOW();//λ
    delay_ms(100);
    LCD_RES_HIGH();
    delay_ms(100);

    LCD_BLK_HIGH();//򿪱
  delay_ms(100);

    LCD_WR_REG(0x11);//Sleep exit
    delay_ms(120);                //Delay 120ms
    LCD_WR_REG(0xB1);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);

    LCD_WR_REG(0xB2);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);

    LCD_WR_REG(0xB3);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);

    LCD_WR_REG(0xB4);     //Dot inversion
    LCD_WR_DATA8(0x03);

    LCD_WR_REG(0xC0);
    LCD_WR_DATA8(0x0E);
    LCD_WR_DATA8(0x0E);
    LCD_WR_DATA8(0x04);

    LCD_WR_REG(0xC1);
    LCD_WR_DATA8(0xC5);

    LCD_WR_REG(0xC2);
    LCD_WR_DATA8(0x0d);
    LCD_WR_DATA8(0x00);

    LCD_WR_REG(0xC3);
    LCD_WR_DATA8(0x8D);
    LCD_WR_DATA8(0x2A);

    LCD_WR_REG(0xC4);
    LCD_WR_DATA8(0x8D);
    LCD_WR_DATA8(0xEE);

    LCD_WR_REG(0xC5);     //VCOM
    LCD_WR_DATA8(0x06); //1D  .06


    LCD_WR_REG(0x36);     //MX, MY, RGB mode
    if(USE_HORIZONTAL==0)LCD_WR_DATA8(0x08);
    else if(USE_HORIZONTAL==1)LCD_WR_DATA8(0xC8);
    else if(USE_HORIZONTAL==2)LCD_WR_DATA8(0x78);
    else LCD_WR_DATA8(0xA8);

    LCD_WR_REG(0x3A);
    LCD_WR_DATA8(0x55);

    LCD_WR_REG(0xE0);
    LCD_WR_DATA8(0x0b);
    LCD_WR_DATA8(0x17);
    LCD_WR_DATA8(0x0a);
    LCD_WR_DATA8(0x0d);
    LCD_WR_DATA8(0x1a);
    LCD_WR_DATA8(0x19);
    LCD_WR_DATA8(0x16);
    LCD_WR_DATA8(0x1d);
    LCD_WR_DATA8(0x21);
    LCD_WR_DATA8(0x26);
    LCD_WR_DATA8(0x37);
    LCD_WR_DATA8(0x3c);
    LCD_WR_DATA8(0x00);
    LCD_WR_DATA8(0x09);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x10);

    LCD_WR_REG(0xE1);
    LCD_WR_DATA8(0x0c);
    LCD_WR_DATA8(0x19);
    LCD_WR_DATA8(0x09);
    LCD_WR_DATA8(0x0d);
    LCD_WR_DATA8(0x1b);
    LCD_WR_DATA8(0x19);
    LCD_WR_DATA8(0x15);
    LCD_WR_DATA8(0x1d);
    LCD_WR_DATA8(0x21);
    LCD_WR_DATA8(0x26);
    LCD_WR_DATA8(0x39);
    LCD_WR_DATA8(0x3E);
    LCD_WR_DATA8(0x00);
    LCD_WR_DATA8(0x09);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x10);
    LCD_WR_REG(0x29);     //Display on
}








